<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Observação Caract Empresa"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="ObservcaractfiscempresaIncluidoEvent")]
		[Event(name="ObservcaractfiscempresaAtualizadoEvent")]
		[Event(name="ObservcaractfiscempresaExcluidoEvent")]
		[Event(name="ObservcaractfiscempresaSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.Observcaractfiscempresa;
			
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			import br.com.desenv.nepalign.vo.CaracteristicasFiscais;
			// Alguem passa a objeto para ca
			public var observcaractfiscempresa : Observcaractfiscempresa = new Observcaractfiscempresa();
			
			[Bindable]
			private var listaEmpresa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaCaracteristicasFiscais: ArrayCollection = new ArrayCollection();

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
// Combo
				ignComboBoxAutoCompleteEmpresa.selectedIndex = -1;
// Combo
				ignComboBoxAutoCompleteCaracteristicasFiscais.selectedIndex = -1;
				ignTextInputObservacao.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectEmpresa: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaResultHandler);	
				remoteObjectEmpresa.getOperation("listar").send();
				var remoteObjectCaracteristicasFiscais: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("caracteristicasFiscaisService", listarCaracteristicasFiscaisResultHandler);	
				remoteObjectCaracteristicasFiscais.getOperation("listar").send();
				
				// Se e um novo cadastro
				if (isNaN(this.observcaractfiscempresa.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					//ignComboBoxAutoCompleteEmpresa.selectedItem = this.observcaractfiscempresa.empresa;
					//ignComboBoxAutoCompleteCaracteristicasFiscais.selectedItem = this.observcaractfiscempresa.caracteristicasFiscais;
					ignTextInputObservacao.text = this.observcaractfiscempresa.observacao;

				}
			}
			
			private function listarEmpresaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresa = event.result as ArrayCollection;
				listaEmpresa.addItemAt(null, 0);
				
				if (this.observcaractfiscempresa != null && this.observcaractfiscempresa.empresa != null)
				{
					for(var i:int = 1; i <= this.listaEmpresa.length; i++)
					{
						var empresaTemp: EmpresaFisica = this.listaEmpresa.getItemAt(i) as EmpresaFisica;
						
						if (empresaTemp.id == this.observcaractfiscempresa.empresa.id)
						{
							ignComboBoxAutoCompleteEmpresa.selectedIndex = i;
							break;
						}
					}
				}	
			}
			private function listarCaracteristicasFiscaisResultHandler( event: ResultEvent ): void 
			{
				listaCaracteristicasFiscais = event.result as ArrayCollection;
				listaCaracteristicasFiscais.addItemAt(null, 0);
				
				if (this.observcaractfiscempresa != null && this.observcaractfiscempresa.caracteristicasFiscais != null)
				{
					for(var i:int = 1; i <= this.listaCaracteristicasFiscais.length; i++)
					{
						var caracteristicasFiscaisTemp: CaracteristicasFiscais = this.listaCaracteristicasFiscais.getItemAt(i) as CaracteristicasFiscais;
						
						if (caracteristicasFiscaisTemp.id == this.observcaractfiscempresa.caracteristicasFiscais.id)
						{
							ignComboBoxAutoCompleteCaracteristicasFiscais.selectedIndex = i;
							break;
						}
					}
				}	
			}
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(observcaractfiscempresa.id) == false) 
					{
						observcaractfiscempresa.empresa = ignComboBoxAutoCompleteEmpresa.selectedItem; 
						observcaractfiscempresa.caracteristicasFiscais = ignComboBoxAutoCompleteCaracteristicasFiscais.selectedItem; 
						observcaractfiscempresa.observacao = ignTextInputObservacao.text;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("observcaractfiscempresaService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(observcaractfiscempresa); 
					// Se e inclusao
					} 
					else 
					{
						observcaractfiscempresa.empresa = ignComboBoxAutoCompleteEmpresa.selectedItem; 
						observcaractfiscempresa.caracteristicasFiscais = ignComboBoxAutoCompleteCaracteristicasFiscais.selectedItem; 
						observcaractfiscempresa.observacao = ignTextInputObservacao.text;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("observcaractfiscempresaService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(observcaractfiscempresa); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.observcaractfiscempresa = event.result as Observcaractfiscempresa;
				this.dispatchEvent(new ResultEvent("ObservcaractfiscempresaIncluidoEvent",false, true, this.observcaractfiscempresa, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.observcaractfiscempresa = event.result as Observcaractfiscempresa;
				this.dispatchEvent(new Event("ObservcaractfiscempresaAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonAdicionarEmpresa_clickHandler(event:MouseEvent):void
			{
				var empresaFisicaComponenteCadastro: EmpresaFisicaComponenteCadastro = new EmpresaFisicaComponenteCadastro();
				empresaFisicaComponenteCadastro.addEventListener("EmpresaFisicaIncluidoEvent", atualizarListaEmpresaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(empresaFisicaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(empresaFisicaComponenteCadastro);
			}
			
			private function atualizarListaEmpresaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoEmpresa: EmpresaFisica = e.result as EmpresaFisica;
				listaEmpresa.addItem(novoEmpresa);
				ignComboBoxAutoCompleteEmpresa.selectedItem = novoEmpresa;
			}
			protected function buttonAdicionarCaracteristicasFiscais_clickHandler(event:MouseEvent):void
			{
				var caracteristicasFiscaisComponenteCadastro: CaracteristicasFiscaisComponenteCadastro = new CaracteristicasFiscaisComponenteCadastro();
				caracteristicasFiscaisComponenteCadastro.addEventListener("CaracteristicasFiscaisIncluidoEvent", atualizarListaCaracteristicasFiscaisPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(caracteristicasFiscaisComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(caracteristicasFiscaisComponenteCadastro);
			}
			
			private function atualizarListaCaracteristicasFiscaisPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoCaracteristicasFiscais: CaracteristicasFiscais = e.result as CaracteristicasFiscais;
				listaCaracteristicasFiscais.addItem(novoCaracteristicasFiscais);
				ignComboBoxAutoCompleteCaracteristicasFiscais.selectedItem = novoCaracteristicasFiscais;
			}

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoObservcaractfiscempresa" property="selectedItem" required="true" source="{comboBoxSituacaoObservcaractfiscempresa}" trigger="{comboBoxSituacaoObservcaractfiscempresa}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Empresa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresa.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresa" dataProvider="{listaEmpresa}" labelField="id" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarEmpresa" width="30" label="+" click="buttonAdicionarEmpresa_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Caracteristicas Fiscais:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoCaracteristicasFiscais" styleName="labelValidacao" text="{ignComboBoxAutoCompleteCaracteristicasFiscais.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteCaracteristicasFiscais" dataProvider="{listaCaracteristicasFiscais}" labelField="id" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarCaracteristicasFiscais" width="30" label="+" click="buttonAdicionarCaracteristicasFiscais_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Observação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoObservacao" styleName="labelValidacao" text="{ignTextInputObservacao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputObservacao" maxChars="255" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>